# 0 "sound.c"
# 1 "/tmp/nlux/nll//"
# 0 "<built-in>"
# 0 "<command-line>"
# 1 "sound.c"
# 1 "config.h" 1
# 2 "sound.c" 2

# 1 "../include/stdio.h" 1



# 1 "../include/sys/types.h" 1



typedef long long int64_t;
typedef unsigned long long uint64_t;
typedef int int32_t;
typedef unsigned int uint32_t;
typedef short int16_t;
typedef unsigned short uint16_t;
typedef char int8_t;
typedef unsigned char uint8_t;

typedef unsigned long size_t;
typedef unsigned long ssize_t;
typedef uint16_t mode_t;

typedef int pid_t;
typedef unsigned int uid_t;
typedef unsigned int gid_t;

typedef long intptr_t;

typedef __builtin_va_list __va_list;







typedef long off_t;
typedef long useconds_t;
# 5 "../include/stdio.h" 2



typedef struct __nllibc_FILE FILE;

extern FILE *stdin;
extern FILE *stdout;
extern FILE *stderr;

int feof(FILE *stream);
int ferror(FILE *stream);
int fileno(FILE *stream);
FILE *fopen(const char *path, const char *mode);
FILE *fdopen(int fildes, const char *mode);
int fclose(FILE *stream);
int vsprintf(char *str, const char *format, __va_list ap);
int vfprintf(FILE *stream, const char *format, __va_list ap);
int vprintf(const char *format, __va_list ap);
int sprintf(char *str, const char *format, ...);
int fprintf(FILE *stream, const char *format, ...);
int printf(const char *format, ...);
int fgetc(FILE *stream);
int fputc(int c, FILE *stream);
int puts(const char *str);
char *fgets(char *str, int size, FILE *stream);
int fputs(const char *str, FILE *stream);
int fflush(FILE *stream);
size_t fread(void *ptr, size_t size, size_t nmemb, FILE *stream);
size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
int fseek(FILE *stream, long offset, int whence);

int rename(const char *from, const char *to);
# 4 "sound.c" 2
# 1 "../include/stdlib.h" 1







void *malloc(size_t size);
void *calloc(size_t number, size_t size);
void *realloc(void *ptr, size_t size);
void free(void *ptr);
void exit(int status);
void abort(void);
int atexit(void (*function)(void));

int atoi(const char *nptr);
long strtol(const char *nptr, char **endptr, int base);
unsigned long strtoul(const char *nptr, char **endptr, int base);
# 5 "sound.c" 2
# 1 "../include/stdint.h" 1
# 6 "sound.c" 2
# 1 "../include/string.h" 1





# 1 "../include/strings.h" 1





int bcmp(const void *b1, const void *b2, size_t len);
void bcopy(const void *src, void *dst, size_t len);
void bzero(void *b, size_t len);
# 7 "../include/string.h" 2

size_t strlen(const char *s);
char *strcpy(char *dst, const char *src);
char *strncpy(char *dst, const char *src, size_t len);
char *strcat(char *s, const char *append);
int strcmp(const char *s1, const char *s2);
int strncmp(const char *s1, const char *s2, size_t len);
char *strchr(const char *s, int c);
char *strrchr(const char *s, int c);
char *strdup(const char *str);
void *memset(void *dest, int c, size_t len);
void *memcpy(void *dst, const void *src, size_t len);
void *memmove(void *dst, const void *src, size_t len);
int memcmp(const void *b1, const void *b2, size_t len);
void *memchr(const void *b, int c, size_t len);
# 7 "sound.c" 2



# 1 "../include/nllibc/nllibc.h" 1
# 11 "sound.c" 2


# 1 "sound.h" 1



typedef enum {
  SOUND_FILE_TYPE_UNKNOWN = 0,
  SOUND_FILE_TYPE_WAV,
  SOUND_FILE_TYPE_TEXT,

  SOUND_FILE_TYPE_NUM
} sound_file_type_t;

FILE *sound_open(sound_file_type_t type, const char *filename, int samplefreq,
   int channels, int bits, int samplenum);
int sound_write(sound_file_type_t type, FILE *fp, int channels, int bits,
  int samplenum, int *offset, void *frames, int num);
int sound_close(sound_file_type_t type, FILE *fp, int channels, int bits,
  int samplenum, int *offset);
# 14 "sound.c" 2

struct chunk_header {



  uint32_t id;
  uint32_t size;
};


struct riff_chunk_header {
  struct chunk_header header;

  uint32_t format;
};


struct fmt_chunk_header {
  struct chunk_header header;

  uint16_t format_type;
  uint16_t channels;
  uint32_t samples_per_sec;
  uint32_t bytes_per_sec;
  uint16_t block_size;
  uint16_t bits_per_sample;
};


struct data_chunk_header {
  struct chunk_header header;
};


union evalue {
  uint8_t b[4];
  uint16_t h[2];
  uint32_t w[1];
};
# 70 "sound.c"
static uint16_t write_le16(uint16_t val)
{
  union evalue e;
  e.b[0] = val & 0xff;
  e.b[1] = (val >> 8) & 0xff;
  return e.h[0];
}

static uint32_t write_le32(uint32_t val)
{
  union evalue e;
  e.b[0] = val & 0xff;
  e.b[1] = (val >> 8) & 0xff;
  e.b[2] = (val >> 16) & 0xff;
  e.b[3] = (val >> 24) & 0xff;
  return e.w[0];
}

static FILE *sound_null_open(const char *filename, int samplefreq,
        int channels, int bits, int samplenum)
{
  return ((void *)0);
}

static int sound_null_write(FILE *fp, int channels, int bits, int samplenum,
       int *offset, void *frames, int num)
{
  return -1;
}

static int sound_null_close(FILE *fp, int channels, int bits, int samplenum,
       int *offset)
{
  return -1;
}

static FILE *sound_wav_open(const char *filename, int samplefreq,
       int channels, int bits, int samplenum)
{
  FILE *fp = ((void *)0);
  struct riff_chunk_header rhdr;
  struct fmt_chunk_header fhdr;
  struct data_chunk_header dhdr;
  int riffsize, fmtsize, datasize;
  const char *mode;

  if ((samplenum < 0) || (samplefreq <= 0))
    goto err;

  if ((channels != 1) && (channels != 2))
    goto err;

  if ((bits != 8) && (bits != 16) && (bits != 32))
    goto err;


  mode = "w";




  fp = fopen(filename, mode);
  if (!fp)
    goto err;

  datasize = sizeof(struct data_chunk_header) + (channels * (bits / 8) * samplenum);
  fmtsize = sizeof(struct fmt_chunk_header);
  riffsize = sizeof(struct riff_chunk_header) + fmtsize + datasize;

  memset(&rhdr, 0, sizeof(rhdr));
  memset(&fhdr, 0, sizeof(fhdr));
  memset(&dhdr, 0, sizeof(dhdr));

  rhdr.header.id = write_le32(0x46464952);
  rhdr.header.size = write_le32(riffsize - sizeof(struct chunk_header));
  rhdr.format = write_le32(0x45564157);

  fhdr.header.id = write_le32(0x20746d66);
  fhdr.header.size = write_le32(fmtsize - sizeof(struct chunk_header));
  fhdr.format_type = write_le16(0x0001);
  fhdr.channels = write_le16(channels);
  fhdr.samples_per_sec = write_le32(samplefreq);
  fhdr.bytes_per_sec = write_le32((bits / 8) * channels * samplefreq);
  fhdr.block_size = write_le16((bits / 8) * channels);
  fhdr.bits_per_sample = write_le16(bits);

  dhdr.header.id = write_le32(0x61746164);
  dhdr.header.size = write_le32(datasize - sizeof(struct chunk_header));

  if (fwrite(&rhdr, 1, sizeof(struct riff_chunk_header), fp) != sizeof(struct riff_chunk_header))
    goto err;

  if (fwrite(&fhdr, 1, sizeof(struct fmt_chunk_header), fp) != sizeof(struct fmt_chunk_header))
    goto err;

  if (fwrite(&dhdr, 1, sizeof(struct data_chunk_header), fp) != sizeof(struct data_chunk_header))
    goto err;

  return fp;

err:
  if (fp)
    fclose(fp);
  return ((void *)0);
}

static int sound_wav_write(FILE *fp, int channels, int bits, int samplenum,
      int *offset, void *frames, int num)
{
  int i, ch, n = 0;
  union evalue e;

  if (!fp)
    return -1;

  for (i = 0; i < num; i++) {
    for (ch = 0; ch < channels; ch++) {
      memset(&e, 0, sizeof(e));
      if (*offset < samplenum) {
 switch (bits) {
 case 8: e.b[0] = ((int8_t *)frames)[n] ; break;
 case 16: e.h[0] = write_le16(((int16_t *)frames)[n]); break;
 case 32: e.w[0] = write_le32(((int32_t *)frames)[n]); break;
 default: break;
 }
      }
      fwrite(&e, 1, bits / 8, fp);
      n++;
    }
    (*offset)++;
  }

  return 0;
}

static int sound_wav_close(FILE *fp, int channels, int bits, int samplenum,
      int *offset)
{
  int align_num, ch;
  union evalue e;

  if (!fp)
    return -1;

  align_num = samplenum;
  if ((channels == 1) && (bits == 8) && ((samplenum % 2) != 0))
    align_num++;

  memset(&e, 0, sizeof(e));

  while (*offset < align_num) {
    for (ch = 0; ch < channels; ch++) {
      fwrite(&e, 1, bits / 8, fp);
    }
    (*offset)++;
  }

  fclose(fp);

  return 0;
}

static FILE *sound_text_open(const char *filename, int samplefreq,
        int channels, int bits, int samplenum)
{
  FILE *fp = ((void *)0);
  const char *mode;

  if ((samplenum < 0) || (samplefreq <= 0))
    goto err;

  if ((bits != 8) && (bits != 16) && (bits != 32))
    goto err;

  mode = "w";

  fp = fopen(filename, mode);
  if (!fp)
    goto err;

  fprintf(fp, "# %s\n", filename);
  fprintf(fp, "# Freq: %d\n", samplefreq);
  fprintf(fp, "# Channels: %d\n", channels);
  fprintf(fp, "# Bits: %d\n", bits);
  fprintf(fp, "# Length: %d\n", samplenum);

  return fp;

err:
  if (fp)
    fclose(fp);
  return ((void *)0);
}

static int sound_text_write(FILE *fp, int channels, int bits, int samplenum,
       int *offset, void *frames, int num)
{
  int i, ch, n = 0, val;

  if (!fp)
    return -1;

  for (i = 0; i < num; i++) {
    fprintf(fp, "%d", *offset);
    for (ch = 0; ch < channels; ch++) {
      val = 0;
      if (*offset < samplenum) {
 switch (bits) {
 case 8: val = ((int8_t *)frames)[n]; break;
 case 16: val = ((int16_t *)frames)[n]; break;
 case 32: val = ((int32_t *)frames)[n]; break;
 default: break;
 }
      }
      fprintf(fp, " %d", val);
      n++;
    }
    fprintf(fp, "\n");
    (*offset)++;
  }

  return 0;
}

static int sound_text_close(FILE *fp, int channels, int bits, int samplenum,
       int *offset)
{
  if (!fp)
    return -1;

  fclose(fp);

  return 0;
}

static struct {
  FILE *(*open)(const char *filename, int samplefreq, int channels, int bits,
  int samplenum);
  int (*write)(FILE *fp, int channels, int bits, int samplenum, int *offset,
        void *frames, int num);
  int (*close)(FILE *fp, int channels, int bits, int samplenum, int *offset);
} functions[] = {
  { sound_null_open, sound_null_write, sound_null_close },
  { sound_wav_open, sound_wav_write, sound_wav_close },
  { sound_text_open, sound_text_write, sound_text_close },

  { ((void *)0), ((void *)0), ((void *)0) }
};

FILE *sound_open(sound_file_type_t type, const char *filename, int samplefreq,
   int channels, int bits, int samplenum)
{
  if (type >= SOUND_FILE_TYPE_NUM)
    return ((void *)0);
  return functions[type].open(filename, samplefreq, channels, bits, samplenum);
}

int sound_write(sound_file_type_t type, FILE *fp, int channels, int bits,
  int samplenum, int *offset, void *frames, int num)
{
  if (type >= SOUND_FILE_TYPE_NUM)
    return -1;
  return functions[type].write(fp, channels, bits, samplenum, offset, frames, num);
}

int sound_close(sound_file_type_t type, FILE *fp, int channels, int bits,
  int samplenum, int *offset)
{
  if (type >= SOUND_FILE_TYPE_NUM)
    return -1;
  return functions[type].close(fp, channels, bits, samplenum, offset);
}
